﻿/*
 * Created by SharpDevelop.
 * 
 * To change this template use Tools | Options | Coding | Edit Standard Headers.
 */
using System;
using System.Text;
using System.IO;
using System.Runtime.InteropServices;


namespace DLLChange
{
	class Change
  {
    [DllImport("KERNEL32.DLL", EntryPoint = "BeginUpdateResourceW", SetLastError = true,
        CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.StdCall)]
    public static extern IntPtr BeginUpdateResource(string pFileName, bool bDeleteExistingResources);


    [DllImport("KERNEL32.DLL", EntryPoint = "UpdateResourceW", SetLastError = true,
       CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.StdCall)]
    public static extern bool UpdateResource(IntPtr hUpdate, string pType, UInt32 pName, UInt16 wLanguage, byte[] pData, UInt32 cbData);

    [DllImport("KERNEL32.DLL", EntryPoint = "EndUpdateResourceW", SetLastError = true,
       CharSet = CharSet.Unicode, ExactSpelling = true, CallingConvention = CallingConvention.StdCall)]
    public static extern bool EndUpdateResource(IntPtr hUpdate, bool bDiscard);

    static void Main()
    {
       IntPtr toChange = BeginUpdateResource(@"ExplorerFrame.dll", false);
       
       string resT = "UIFILE";                     
   
       UInt32 resN = 40960;                                     

       FileStream inp = new FileStream(@"Test.xml", FileMode.Open);

       BinaryReader dll = new BinaryReader(inp);

       byte[] inByteArray = dll.ReadBytes((int)inp.Length);

       bool result = UpdateResource(toChange, resT, resN, 1049, inByteArray, (uint)inByteArray.Length);

       EndUpdateResource(toChange, false);

       dll.Close();
       inp.Close();
    }
  }
}